/[gentoo-x86]/eclass/elisp-common.eclass
Gentoo

Diff of /eclass/elisp-common.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.10 Revision 1.25
1# Copyright 1999-2004 Gentoo Foundation 1# Copyright 1999-2007 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/elisp-common.eclass,v 1.10 2005/05/03 09:20:13 usata Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/elisp-common.eclass,v 1.25 2007/07/25 04:46:01 ulm Exp $
4# 4#
5# Copyright 2007 Christian Faulhammer <opfer@gentoo.org>
5# Copyright 2002-2003 Matthew Kennedy <mkennedy@gentoo.org> 6# Copyright 2002-2004 Matthew Kennedy <mkennedy@gentoo.org>
7# Copyright 2004-2005 Mamoru Komachi <usata@gentoo.org>
6# Copyright 2003 Jeremy Maitin-Shepard <jbms@attbi.com> 8# Copyright 2003 Jeremy Maitin-Shepard <jbms@attbi.com>
9# Copyright 2007 Ulrich Mueller <ulm@gentoo.org>
7# 10#
8# This is not an eclass, but it does provide emacs-related 11# @ECLASS: elisp-common.eclass
9# installation utilities. 12# @MAINTAINER:
10 13# Feel free to contact the Emacs team through emacs@gentoo.org if you have
11ECLASS=elisp-common 14# problems, suggestions or questions.
12INHERITED="$INHERITED $ECLASS" 15# @BLURB: Emacs-related installation utilities
16# @DESCRIPTION:
17#
18# Usually you want to use this eclass for (optional) GNU Emacs support of
19# your package. This is NOT for XEmacs!
20#
21# Many of the steps here are sometimes done by the build system of your
22# package (especially compilation), so this is mainly for standalone elisp
23# files you gathered from somewhere else.
24#
25# When relying on the emacs USE flag, you need to add
26#
27# emacs? ( virtual/emacs )
28#
29# to your DEPEND/RDEPEND line and use the functions provided here to bring
30# the files to the correct locations.
31#
32# .SS
33# src_compile() usage:
34#
35# An elisp file is compiled by the elisp-compile() function defined here and
36# simply takes the source files as arguments.
37#
38# elisp-compile *.el || die "elisp-compile failed"
39#
40# In the case of interdependent elisp files, you can use the elisp-comp()
41# function which makes sure all files are loadable.
42#
43# elisp-comp *.el || die "elisp-comp failed"
44#
45# Function elisp-make-autoload-file() can be used to generate a file with
46# autoload definitions for the lisp functions. It takes the output file name
47# (default: "${PN}-autoloads.el") and a list of directories (default: working
48# directory) as its arguments. Use of this function requires that the elisp
49# source files contain magic ";;;###autoload" comments. See the Emacs Lisp
50# Reference Manual (node "Autoload") for a detailed explanation.
51#
52# .SS
53# src_install() usage:
54#
55# The resulting compiled files (.elc) should be put in a subdirectory of
56# /usr/share/emacs/site-lisp/ which is named after the first argument
57# of elisp-install(). The following parameters are the files to be put in
58# that directory. Usually the subdirectory should be ${PN}, you can choose
59# something else, but remember to tell elisp-site-file-install() (see below)
60# the change, as it defaults to ${PN}.
61#
62# elisp-install ${PN} *.el *.elc || die "elisp-install failed"
63#
64# To let the Emacs support be activated by Emacs on startup, you need
65# to provide a site file (shipped in ${FILESDIR}) which contains the startup
66# code (have a look in the documentation of your software). Normally this
67# would look like this:
68#
69# .nf
70# ;;; csv-mode site-lisp configuration
71#
72# (add-to-list 'load-path "@SITELISP@")
73# (add-to-list 'auto-mode-alist '("\\.csv\\'" . csv-mode))
74# (autoload 'csv-mode "csv-mode" "Major mode for csv files." t)
75# .fi
76#
77# If your Emacs support files are installed in a subdirectory of
78# /usr/share/emacs/site-lisp/ (which is recommended if more than one file is
79# installed), you need to extend Emacs' load-path as shown in the first
80# non-comment. The elisp-site-file-install() function of this eclass will
81# replace "@SITELISP@" by the actual path.
82#
83# The next line tells Emacs to load the mode opening a file ending with
84# ".csv" and load functions depending on the context and needed features.
85# Be careful though. Commands as "load-library" or "require" bloat the
86# editor as they are loaded on every startup. When having a lot of Emacs
87# support files, users may be annoyed by the start-up time. Also avoid
88# keybindings as they might interfere with the user's settings. Give a hint
89# in pkg_postinst(), which should be enough.
90#
91# The naming scheme for this site file is "[0-9][0-9]*-gentoo.el", where the
92# two digits at the beginning define the loading order. So if you depend on
93# another Emacs package, your site file's number must be higher!
94#
95# Best practice is to define a SITEFILE variable in the global scope of your
96# ebuild (right after DEPEND e.g.):
97#
98# SITEFILE=50${PN}-gentoo.el
99#
100# Which is then installed by
101#
102# elisp-site-file-install "${FILESDIR}/${SITEFILE}"
103#
104# in src_install(). If your subdirectory is not named ${PN}, give the
105# differing name as second argument.
106#
107# .SS
108# pkg_postinst() / pkg_postrm() usage:
109#
110# After that you need to recreate the start-up file of Emacs after emerging
111# and unmerging by using
112#
113# .nf
114# pkg_postinst() {
115# elisp-site-regen
116# }
117#
118# pkg_postrm() {
119# elisp-site-regen
120# }
121# .fi
122#
123# When having optional Emacs support, you should prepend "use emacs &&" to
124# above calls of elisp-site-regen(). Don't use "has_version virtual/emacs"!
125# When unmerging the state of the emacs USE flag is taken from the package
126# database and not from the environment, so it is no problem when you unset
127# USE=emacs between merge and unmerge of a package.
128#
129# .SS
130# Miscellaneous functions:
131#
132# elisp-emacs-version() outputs the version of the currently active Emacs.
13 133
14SITELISP=/usr/share/emacs/site-lisp 134SITELISP=/usr/share/emacs/site-lisp
135SITEFILE=50${PN}-gentoo.el
136
137# @FUNCTION: elisp-compile
138# @USAGE: <list of elisp files>
139# @DESCRIPTION:
140# Byte-compile Emacs Lisp files.
15 141
16elisp-compile() { 142elisp-compile() {
17 /usr/bin/emacs --batch -f batch-byte-compile --no-site-file --no-init-file $* 143 einfo "Compiling GNU Emacs Elisp files ..."
144 /usr/bin/emacs -batch -q --no-site-file -f batch-byte-compile $*
18} 145}
146
147# @FUNCTION: elisp-emacs-version
148# @DESCRIPTION:
149# Output version of currently active Emacs.
150
151elisp-emacs-version() {
152 # The following will work for at least versions 18-22.
153 echo "(princ emacs-version)" >"${T}"/emacs-version.el
154 /usr/bin/emacs -batch -q --no-site-file -l "${T}"/emacs-version.el
155}
156
157# @FUNCTION: elisp-make-autoload-file
158# @USAGE: [output file] [list of directories]
159# @DESCRIPTION:
160# Generate a file with autoload definitions for the lisp functions.
161
162elisp-make-autoload-file () {
163 local f="${1:-${PN}-autoloads.el}"
164 shift
165 einfo "Generating autoload file for GNU Emacs ..."
166
167 sed 's/^FF/\f/' >"${f}" <<-EOF
168 ;;; ${f##*/} --- autoloads for ${P}
169
170 ;;; Commentary:
171 ;; Automatically generated by elisp-common.eclass
172 ;; DO NOT EDIT THIS FILE
173
174 ;;; Code:
175 FF
176 ;; Local Variables:
177 ;; version-control: never
178 ;; no-byte-compile: t
179 ;; no-update-autoloads: t
180 ;; End:
181 ;;; ${f##*/} ends here
182 EOF
183
184 /usr/bin/emacs -batch -q --no-site-file \
185 --eval "(setq make-backup-files nil)" \
186 --eval "(setq generated-autoload-file (expand-file-name \"${f}\"))" \
187 -f batch-update-autoloads "${@-.}"
188}
189
190# @FUNCTION: elisp-install
191# @USAGE: <subdirectory> <list of files>
192# @DESCRIPTION:
193# Install files in SITELISP directory.
19 194
20elisp-install() { 195elisp-install() {
21 local subdir=$1 196 local subdir=$1
197 einfo "Installing Elisp files for GNU Emacs support ..."
22 dodir ${SITELISP}/${subdir} 198 dodir "${SITELISP}/${subdir}"
23 insinto ${SITELISP}/${subdir} 199 insinto "${SITELISP}/${subdir}"
24 shift 200 shift
25 doins $@ 201 doins $@
26} 202}
27 203
204# @FUNCTION: elisp-site-file-install
205# @USAGE: <site-init file> [subdirectory]
206# @DESCRIPTION:
207# Install Emacs site-init file in SITELISP directory.
208
28elisp-site-file-install() { 209elisp-site-file-install() {
29 local sitefile=$1 my_pn=${2:-${PN}} 210 local sitefile=$1 my_pn=${2:-${PN}}
211 einfo "Installing site initialisation file for GNU Emacs ..."
30 pushd ${S} 212 pushd "${S}"
31 cp ${sitefile} ${T} 213 cp ${sitefile} "${T}"
32 sed -i "s:@SITELISP@:${SITELISP}/${my_pn}:g" ${T}/$(basename ${sitefile}) 214 sed -i "s:@SITELISP@:${SITELISP}/${my_pn}:g" "${T}/$(basename ${sitefile})"
33 insinto ${SITELISP} 215 insinto ${SITELISP}
34 doins ${T}/$(basename ${sitefile}) || die "failed to install site file" 216 doins "${T}/$(basename ${sitefile})" || die "failed to install site file"
35 popd 217 popd
36} 218}
37 219
220# @FUNCTION: elisp-site-regen
221# @DESCRIPTION:
222# Regenerate site-gentoo.el file.
223
38elisp-site-regen() { 224elisp-site-regen() {
225 local sflist sf line
226
39 einfo "Regenerating ${SITELISP}/site-gentoo.el ..." 227 einfon "Regenerating ${SITELISP}/site-gentoo.el ..."
40 einfo ""
41 cat <<EOF >${SITELISP}/site-gentoo.el 228 cat <<-EOF >"${T}"/site-gentoo.el
42;;; DO NOT EDIT THIS FILE -- IT IS GENERATED AUTOMATICALLY BY PORTAGE 229 ;;; site-gentoo.el --- site initialisation for Gentoo-installed packages
43;;; -----------------------------------------------------------------
44 230
231 ;;; Commentary:
232 ;; Automatically generated by elisp-common.eclass
233 ;; DO NOT EDIT THIS FILE
234
235 ;;; Code:
45EOF 236 EOF
46 ls ${SITELISP}/[0-9][0-9]*-gentoo.el |sort -n | \ 237
47 while read sf 238 for sf in "${ROOT}${SITELISP}"/[0-9][0-9]*-gentoo.el
48 do 239 do
49 einfo " Adding $(basename $sf) ..." 240 [ -r "${sf}" ] || continue
50 # Great for debugging, too noisy and slow for users though 241 sflist="${sflist} $(basename "${sf}")"
51# echo "(message \"Loading $sf ...\")" >>${SITELISP}/site-start.el
52 cat $sf >>${SITELISP}/site-gentoo.el 242 cat "${sf}" >>"${T}"/site-gentoo.el
53 done 243 done
244
245 cat <<-EOF >>"${T}"/site-gentoo.el
246
247 ;;; site-gentoo.el ends here
248 EOF
249
250 if cmp -s "${ROOT}${SITELISP}"/site-gentoo.el "${T}"/site-gentoo.el; then
251 # This prevents outputting unnecessary text when there
252 # was actually no change
253 # A case is a remerge where we have doubled output
254 echo " no changes."
255 else
256 mv "${T}"/site-gentoo.el "${ROOT}${SITELISP}"/site-gentoo.el
257 echo; einfo
258 for sf in ${sflist}; do
259 einfo " Adding ${sf} ..."
260 done
54 while read line; do einfo "${line}"; done <<EOF 261 while read line; do einfo "${line}"; done <<EOF
55 262
56All site initialization for Gentoo-installed packages is now added to 263All site initialisation for Gentoo-installed packages is added to
57/usr/share/emacs/site-lisp/site-gentoo.el; site-start.el is no longer 264/usr/share/emacs/site-lisp/site-gentoo.el; site-start.el is no longer
58managed by Gentoo. You are responsible for all maintenance of 265managed by Gentoo. You are responsible for all maintenance of
59site-start.el if there is such a file. 266site-start.el if there is such a file.
60 267
61In order for this site initialization to be loaded for all users 268In order for this site initialisation to be loaded for all users
62automatically, as was done previously, you can add a line like this: 269automatically, you can add a line like this:
63 270
64 (load "/usr/share/emacs/site-lisp/site-gentoo") 271 (load "/usr/share/emacs/site-lisp/site-gentoo" nil t)
65 272
66to /usr/share/emacs/site-lisp/site-start.el. Alternatively, that line 273to /usr/share/emacs/site-lisp/site-start.el. Alternatively, that line
67can be added by individual users to their initialization files, or for 274can be added by individual users to their initialisation files, or for
68greater flexibility, users can select which of the package-specific 275greater flexibility, users can select which of the package-specific
69initialization files in /usr/share/emacs/site-lisp to load. 276initialisation files in /usr/share/emacs/site-lisp to load.
70EOF 277EOF
71 echo 278 echo
279 fi
72} 280}
73 281
74# The following Emacs Lisp compilation routine is taken from GNU 282# @FUNCTION: elisp-comp
75# autotools. 283# @USAGE: <list of elisp files>
284# @DESCRIPTION:
285# Byte-compile interdependent Emacs Lisp files.
286# Originally taken from GNU autotools.
76 287
77elisp-comp() { 288elisp-comp() {
78# Copyright 1995 Free Software Foundation, Inc. 289 # Copyright 1995 Free Software Foundation, Inc.
79# Franois Pinard <pinard@iro.umontreal.ca>, 1995. 290 # Franรงois Pinard <pinard@iro.umontreal.ca>, 1995.
80#
81# This program is free software; you can redistribute it and/or modify
82# it under the terms of the GNU General Public License as published by
83# the Free Software Foundation; either version 2, or (at your option)
84# any later version.
85#
86# This program is distributed in the hope that it will be useful,
87# but WITHOUT ANY WARRANTY; without even the implied warranty of
88# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
89# GNU General Public License for more details.
90#
91# You should have received a copy of the GNU General Public License
92# along with this program; if not, write to the Free Software
93# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
94
95# As a special exception to the GNU General Public License, if you
96# distribute this file as part of a program that contains a
97# configuration script generated by Autoconf, you may include it under
98# the same distribution terms that you use for the rest of that program.
99
100# This script byte-compiles all `.el' files which are part of its 291 # This script byte-compiles all `.el' files which are part of its
101# arguments, using GNU Emacs, and put the resulting `.elc' files into 292 # arguments, using GNU Emacs, and put the resulting `.elc' files into
102# the current directory, so disregarding the original directories used 293 # the current directory, so disregarding the original directories used
103# in `.el' arguments. 294 # in `.el' arguments.
104# 295 #
105# This script manages in such a way that all Emacs LISP files to 296 # This script manages in such a way that all Emacs LISP files to
106# be compiled are made visible between themselves, in the event 297 # be compiled are made visible between themselves, in the event
107# they require or load-library one another. 298 # they require or load-library one another.
108 299
109 if test $# = 0; then 300 test $# -gt 0 || return 1
110 echo 1>&2 "No files given to $0" 301
111 exit 1
112 else
113 if test -z "$EMACS" || test "$EMACS" = "t"; then 302 if test -z "${EMACS}" || test "${EMACS}" = "t"; then
114 # Value of "t" means we are running in a shell under Emacs. 303 # Value of "t" means we are running in a shell under Emacs.
115 # Just assume Emacs is called "emacs". 304 # Just assume Emacs is called "emacs".
116 EMACS=emacs 305 EMACS=/usr/bin/emacs
117 fi
118
119 tempdir=elc.$$
120 mkdir $tempdir
121 cp $* $tempdir
122 cd $tempdir
123
124 echo "(add-to-list 'load-path \"../\")" > script
125 $EMACS -batch -q --no-site-file --no-init-file -l script -f batch-byte-compile *.el
126 mv *.elc ..
127
128 cd ..
129 rm -fr $tempdir
130 fi 306 fi
131} 307 einfo "Compiling GNU Emacs Elisp files ..."
132 308
133# Local Variables: *** 309 tempdir=elc.$$
134# mode: shell-script *** 310 mkdir ${tempdir}
135# tab-width: 4 *** 311 cp $* ${tempdir}
136# indent-tabs-mode: t *** 312 pushd ${tempdir}
137# End: ***
138 313
314 echo "(add-to-list 'load-path \"../\")" > script
315 ${EMACS} -batch -q --no-site-file --no-init-file -l script \
316 -f batch-byte-compile *.el
317 local status=$?
318 mv *.elc ..
319
320 popd
321 rm -fr ${tempdir}
322 return ${status}
323}

Legend:
Removed from v.1.10  
changed lines
  Added in v.1.25

  ViewVC Help
Powered by ViewVC 1.1.20